//------------------------------------------------------------------------------
// GPL LICENSE (short)
//------------------------------------------------------------------------------
/*
 * Copyright (c) 2020 R1KO, T1MOX4, vadrozh

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 * ChangeLog:
		1.0.0 -	Релиз
		1.0.1 -	Обновление плагина под новую версию ядра 3.0
		1.0.2 - Незначительные правки, запрет выдачи на пистолетных раундах
*/

#pragma semicolon 1
#pragma newdecls required

#include <sdktools>
#include <cstrike>
#include <vip_core>

public Plugin myinfo = {
	name = "[VIP] Defuser",
	author = "R1KO, T1MOX4, vadrozh",
	description = "Выдача набора обезвреживания VIP-игрокам",
	version = "1.0.2",
	url = "https://hlmod.ru"
};

static const char g_sFeature[] = "Defuser";
int g_bHasDefuser = -1;

public void OnPluginStart() {
	g_bHasDefuser = UTIL_FindSendPropInfo("CCSPlayer", "m_bHasDefuser");
	
	if(VIP_IsVIPLoaded())
		VIP_OnVIPLoaded();
}

public void OnPluginEnd() {
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
		VIP_UnregisterFeature(g_sFeature);
}

int UTIL_GetCurrentRound() { return CS_GetTeamScore(CS_TEAM_T) + CS_GetTeamScore(CS_TEAM_CT) + 1; }

int UTIL_FindSendPropInfo(const char[] sNetClass, const char[] sPropertyName) {
	int iOffset = FindSendPropInfo(sNetClass, sPropertyName);
	if (iOffset == -1)
		SetFailState("Unable to find offset: \"%s::%s\"", sNetClass, sPropertyName);
	return iOffset;
}

public void VIP_OnVIPLoaded() { VIP_RegisterFeature(g_sFeature, BOOL); }

public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP) {
	if(bIsVIP && iTeam == 3 && VIP_IsClientFeatureUse(iClient, g_sFeature) && GetEntData(iClient, g_bHasDefuser) != 1){
		int iRound = UTIL_GetCurrentRound();
		if (iRound != 1 && iRound != 16)
			SetEntData(iClient, g_bHasDefuser, 1);
	}
}